function dr=model(t,U)

Vms=U(1);
ms=U(2);
hs=U(3);
xss=U(4);
r2s=U(5);
r3s=U(6);
Cai=U(7);
Vmt=U(8);
mt=U(9);
ht=U(10);
xst=U(11);
dt=U(12);
ft=U(13);
Kt_1=U(14);
Nat=U(15);
Cat_1=U(16);
Nai=U(17);
Ki=U(18);
BTRH=U(19);
BTRL=U(20);
CaSRup=U(21);
CaSRrel_t=U(22);
Cadt=U(23);
F1t=U(24);
F2t=U(25);
F3t=U(26);
F4t=U(27);
r4s=U(28);
Cst=U(29);
C1=U(30);
C2=U(31);
C3=U(32);
C4=U(33);
Co=U(34);
Ccast=U(35);
Cca1=U(36);
Cca2=U(37);
Cca3=U(38);
Cca4=U(39);
Ccao=U(40);
ys=U(41);
TCst=U(42);
TC1=U(43);
TC2=U(44);
TC3=U(45);
TC4=U(46);
TCo=U(47);
TCcast=U(48);
TCca1=U(49);
TCca2=U(50);
TCca3=U(51);
TCca4=U(52);
TCcao=U(53);
yt=U(54);
r2t=U(55);
r3t=U(56);
r4t=U(57);
xrs=U(58);
xrt=U(59);
xris=U(60);
xrit=U(61);
C0_Na=U(62);
C1_Na=U(63);
C2_Na=U(64);
C3_Na=U(65);
C4_Na=U(66);
O1_Na=U(67);
O2_Na=U(68);
IC0_Na=U(69);
IC1_Na=U(70);
IC2_Na=U(71);
IC3_Na=U(72);
IC4_Na=U(73);
IO1_Na=U(74);
MC0_Na=U(75);
MC1_Na=U(76);
MC2_Na=U(77);
MC3_Na=U(78);
MC4_Na=U(79);
MO1_Na=U(80);
MO2_Na=U(81);
TC0_Na=U(82);
TC1_Na=U(83);
TC2_Na=U(84);
TC3_Na=U(85);
TC4_Na=U(86);
TO1_Na=U(87);
TO2_Na=U(88);
TIC0_Na=U(89);
TIC1_Na=U(90);
TIC2_Na=U(91);
TIC3_Na=U(92);
TIC4_Na=U(93);
TIO1_Na=U(94);
TMC0_Na=U(95);
TMC1_Na=U(96);
TMC2_Na=U(97);
TMC3_Na=U(98);
TMC4_Na=U(99);
TMO1_Na=U(100);
TMO2_Na=U(101);
MO1_Na2=U(102);
Cat_2=U(103);
Cat_3=U(104);
Cat_4=U(105);
Cat_5=U(106);
Cat_6=U(107);
Cat_7=U(108);
Cat_8=U(109);
Cat_9=U(110);
Kt_2=U(111);
Kt_3=U(112);
Kt_4=U(113);
Kt_5=U(114);
Kt_6=U(115);
Kt_7=U(116);
Kt_8=U(117);
Kt_9=U(118);
Ke=U(119);
Nae=U(120);
Cae=U(121);
Cads=U(122);
CaSRrel_s=U(123);
F1s=U(124);
F2s=U(125);
F3s=U(126);
F4s=U(127);
Kss=U(128);
Nass=U(129); 
Cass=U(130);
Kst=U(131);
Nast=U(132); 
Cast=U(133);



%*****Global variables*****
global R T F Rot Rst Rel Vel 
global Smtot Sms Smt Cms Cmt
global Lt radiust ptcm To t0
global Nab Cab Kb ATPi Cap
global gNa gNas gNat gNaps gNapss gNapst gK1 gK1s gK1t gKp gKps gKpt gKto gKtos gKtot gKsNa gKsNas gKsNat gKatp gKatps gKatpt gNab gNabs gNabt gCab gCabs gCabt
global INaCamax INaCamaxs INaCamaxt INaKmax INaKmaxs INaKmaxt IpCamax IpCamaxs IpCamaxt 
global PCa PCas PCat PNal PNals PNalt PKl PKls PKlt PnsNa PnsNas PnsNat PnsK PnsKs PnsKt
global qKs qKss qKst qKr qKrs qKrt
global fNat fNapst fCat fKst fKrt fK1t fKpt fKsNat fKatpt fnsNat fnsKt fNabt fCabt fNaCat fNaKt fpCat fKtot fVs_t
global ICCC ICCT VCLAMP STIMULATION DIALYSIS



%*****Surface membrane area [cm^2]*****
Sms=Smtot*0.443;

%*****T-tubular membrane area [cm^2]*****
Smt=Smtot*0.557;

%*****Volume of cell [ml]***** 
Vc=Smt/0.4e4;

%*****Volume of myoplasma [ml]*****
Vmyo=Vc*0.68;

%*****Volume of extracellular cleft space [ml]*****
Ve=Vmyo*0.136; 

%*****Volume of NSR [ml]*****
VSRup=Vc*0.68*0.081;  

%*****Volumes of JSR [ml]*****
VSRrel_t=Vc*0.68*0.0062*fCat;
VSRrel_s=Vc*0.68*0.0062*(1-fCat);

%*****Volumes of dyadic spaces [ml]*****
Vd_t=Vc*0.68*0.0000464*fCat; 
Vd_s=Vc*0.68*0.0000464*(1-fCat); 

%*****Volumes of submembrane spaces [ml]*****
Vs_t=Vc*0.68*0.029*fVs_t; 
Vs_s=Vc*0.68*0.029*(1-fVs_t);

%*****Number of T-tubules [n]*****
pt=ptcm*Sms;

%*****Volume of T-tubules [ml]*****
Vt=3.14159*radiust^2*Lt*pt;

%*****Mean length of T-tubule adjacent to T-tubular submembrane space [cm]*****
Lt_st=Lt*0.794;

%*****Volume of submembrane space around one T-tubule [ml]*****
Vs_t1=Vs_t/pt;

%*****Outer radius of submembrane space around T-tubules [cm]*****
rs_t=sqrt(Vs_t1/(pi*Lt_st)+radiust^2);

%*****Difusional area between T-tubular and surface submembrane spaces [cm^2]*****
Sdiff_ss_st=pi*(rs_t^2-radiust^2)*pt;

%*****Permeability between T-tubular and surface submembrane spaces [cm/s]*****
Tau_Ca_css=4.00362319E-5; 
Pssc=Vs_s/Tau_Ca_css;
Pstss=Pssc*Sdiff_ss_st/(Sms*0.954);

%*****Volumes of T-tubule segments [ml]*****
nred=3.7037; 
Vt_1=Vt/(9*nred);
Vt_2=Vt/(9*nred);
Vt_3=Vt/(9*nred);
Vt_4=Vt/(9*nred);
Vt_5=Vt/(9*nred);
Vt_6=Vt/(9*nred);
Vt_7=Vt/(9*nred);
Vt_8=Vt/(9*nred);
Vt_9=Vt-Vt_8-Vt_7-Vt_6-Vt_5-Vt_4-Vt_3-Vt_2-Vt_1;

%*****Radii of T-tubule segments [cm]*****
rt_1=radiust;
rt_2=((Vt_2+Vt_3+Vt_4+Vt_5+Vt_6+Vt_7+Vt_8+Vt_9)/(Lt*pt*3.14159))^0.5;
rt_3=((Vt_3+Vt_4+Vt_5+Vt_6+Vt_7+Vt_8+Vt_9)/(Lt*pt*3.14159))^0.5;
rt_4=((Vt_4+Vt_5+Vt_6+Vt_7+Vt_8+Vt_9)/(Lt*pt*3.14159))^0.5;
rt_5=((Vt_5+Vt_6+Vt_7+Vt_8+Vt_9)/(Lt*pt*3.14159))^0.5;
rt_6=((Vt_6+Vt_7+Vt_8+Vt_9)/(Lt*pt*3.14159))^0.5;
rt_7=((Vt_7+Vt_8+Vt_9)/(Lt*pt*3.14159))^0.5;
rt_8=((Vt_8+Vt_9)/(Lt*pt*3.14159))^0.5;
rt_9=(Vt_9/(Lt*pt*3.14159))^0.5;

%*****T-tubular membrane capacitance [uF]*****
Cmt=Smt;

%*****Surface membrane capacitance [uF]*****
Cms=Sms;

%*****T-tubular series resistance [Ohm]*****
Rst=Rot*(Lt/2)/(3.14159*radiust^2*pt);

%*****Ion conductivities, permeabilities or maximum currents of surface and T-tubular membranes*****  
gNas=gNa*(Sms+Smt)*(1-fNat);               gNat=gNa*(Sms+Smt)*fNat;   
gNapss=gNaps*(Sms+Smt)*(1-fNapst);         gNapst=gNaps*(Sms+Smt)*fNapst;
qKss=qKs*(Sms+Smt)*(1-fKst);               qKst=qKs*(Sms+Smt)*fKst;   
qKrs=qKr*(Sms+Smt)*(1-fKrt);               qKrt=qKr*(Sms+Smt)*fKrt;   
gK1s=gK1*(Sms+Smt)*(1-fK1t);               gK1t=gK1*(Sms+Smt)*fK1t;   
gKps=gKp*(Sms+Smt)*(1-fKpt);               gKpt=gKp*(Sms+Smt)*fKpt;   
gKtos=gKto*(Sms+Smt)*(1-fKtot);            gKtot=gKto*(Sms+Smt)*fKtot;
gKsNas=gKsNa*(Sms+Smt)*(1-fKsNat);         gKsNat=gKsNa*(Sms+Smt)*fKsNat;
gNabs=gNab*(Sms+Smt)*(1-fNabt);            gNabt=gNab*(Sms+Smt)*fNabt;
gCabs=gCab*(Sms+Smt)*(1-fCabt);            gCabt=gCab*(Sms+Smt)*fCabt;
gKatps=gKatp*(Sms+Smt)*(1-fKatpt);         gKatpt=gKatp*(Sms+Smt)*fKatpt;
PCas=PCa*(Sms+Smt)*(1-fCat);               PCat=PCa*(Sms+Smt)*fCat;   
PNals=PNal*(Sms+Smt)*(1-fCat);             PNalt=PNal*(Sms+Smt)*fCat; 
PKls=PKl*(Sms+Smt)*(1-fCat);               PKlt=PKl*(Sms+Smt)*fCat;   
PnsNas=PnsNa*(Sms+Smt)*(1-fnsNat);         PnsNat=PnsNa*(Sms+Smt)*fnsNat;
PnsKs=PnsK*(Sms+Smt)*(1-fnsKt);            PnsKt=PnsK*(Sms+Smt)*fnsKt;
INaCamaxs=INaCamax*(Sms+Smt)*(1-fNaCat);   INaCamaxt=INaCamax*(Sms+Smt)*fNaCat;
INaKmaxs=INaKmax*(Sms+Smt)*(1-fNaKt);      INaKmaxt=INaKmax*(Sms+Smt)*fNaKt;
IpCamaxs=IpCamax*(Sms+Smt)*(1-fpCat);      IpCamaxt=IpCamax*(Sms+Smt)*fpCat;



%*****IONIC CURRENTS*************
%*****Stimulation pulse [uA]*****
if VCLAMP==0 && STIMULATION==1 && (t-t0)<0.001
   IKext=45*(Sms+Smt);   % by 50% higher than threshold
else
   IKext=0;
end;

if STIMULATION==1 
   IKequ=45*(Sms+Smt)*0.001/To;
else
   IKequ=0;
end;
 
if VCLAMP==1
   IKext=1000*(Vel-Vms)/Rel;
end;


%*****Fast sodium current [uA]*****
%Surface
ENas=log(Nae/Nass)*R*T/F;
msinf=1./(1+exp((Vms+52.2-9)/-7.4));
hsinf=1./(1+exp((Vms+85.6-9)/+5.5));
taums=(0.001./(101.6*exp(Vms*0.1135)+0.02268*exp(-0.0717*Vms))+0.0001)/4.83;
tauhs=(0.001./(1.1381e-6*exp(-0.1017*Vms)+6.537*exp(Vms*0.08016))+0.0005)/4.83;
dms=(msinf-ms)/taums;
dhs=(hsinf-hs)/tauhs;
%INas=gNas*ms^3*hs*(Vms-log((Nae+0.12*Ke)/(Nass+0.12*Kss))*R*T/F);

%New description
m_ons=0;
m_offs=0;
a=7.5;
par_H=(-19.8282-50/8.315)*2544.39;
alfa=2.0842e+10*T*exp(par_H/(8.315*T)+50/8.315+0.2864*11.594*Vms/T);
beta=2.0842e+10*T*exp(-272470/(8.315*T)+691.732/8.315-2.5*11.594*Vms/T);
gama=2.8950e+10*T*exp(-196337/(8.315*T)+529.952/8.315+1.5703*11.594*Vms/T);
delta=2.8950e+10*T*exp(-133690/(8.315*T)+229.205/8.315-1.558*11.594*Vms/T);
i_on_2=2.0842e+10*T*exp(-62123/(8.315*T)+28.6847/8.315+0.2888*11.594*Vms/T);
epsilon=2.8950e+10*T*exp(-85800/(8.315*T)+70.078/8.315);
eta=2.8950e+10*T*exp(-147814/(8.315*T)+338.915/8.315+0.75*11.594*Vms/T);
par_H=(-26.4132-1.76851/8.315)*2544.39;
theta=2.0842e+10*T*exp(par_H/(8.315*T)+1.76851/8.315-1.7*11.594*Vms/T); 
omega=epsilon*theta*gama/(eta*delta);
i_off=0.01*2.8950e+10*T*exp(-287913/(8.3148*T)+786.217/8.315);
i_on=0.05*2.8950e+10*T*exp(-59565/(8.3148*T)+0.00711/8.315);            
delta_2=2.8950e+10*T*exp(-55701/(8.315*T)-130.639/8.315-3.6498*11.594*Vms/T);
gama_2=2.8950e+10*T*exp(116431/(8.315*T)-578.317/8.315+0.7641*11.594*Vms/T);
i_off_2=delta_2*i_on_2*gama*i_off/a^4/(i_on*delta*a^4*gama_2);          
dIC0_Na=C0_Na*i_on+IC1_Na*beta/a-IC0_Na*(4*alfa*a+i_off);
dIC1_Na=C1_Na*i_on*a^1+IC2_Na*2*beta/a+IC0_Na*4*alfa*a-IC1_Na*(3*alfa*a+i_off/a+beta/a);
dIC2_Na=C2_Na*i_on*a^2+IC3_Na*3*beta/a+IC1_Na*3*alfa*a-IC2_Na*(2*alfa*a+i_off/a^2+2*beta/a);
dIC3_Na=C3_Na*i_on*a^3+IC4_Na*4*beta/a+IC2_Na*2*alfa*a-IC3_Na*(alfa*a+i_off/a^3+3*beta/a);
dIC4_Na=C4_Na*i_on*a^4+IO1_Na*delta_2+IC3_Na*alfa*a-IC4_Na*(gama_2+i_off/a^4+4*beta/a);
dIO1_Na=O1_Na*i_on_2+IC4_Na*gama_2-IO1_Na*(delta_2+i_off_2);
dC0_Na=IC0_Na*i_off+C1_Na*beta+MC0_Na*m_offs-C0_Na*(i_on+4*alfa+m_ons);
dC1_Na=IC1_Na*i_off/a^1+C2_Na*2*beta+MC1_Na*m_offs+C0_Na*4*alfa-C1_Na*(i_on*a^1+3*alfa+m_ons+beta);
dC2_Na=IC2_Na*i_off/a^2+C3_Na*3*beta+MC2_Na*m_offs+C1_Na*3*alfa-C2_Na*(i_on*a^2+2*alfa+m_ons+2*beta);
dC3_Na=IC3_Na*i_off/a^3+C4_Na*4*beta+MC3_Na*m_offs+C2_Na*2*alfa-C3_Na*(i_on*a^3+alfa+m_ons+3*beta);
dC4_Na=IC4_Na*i_off/a^4+O1_Na*delta+MC4_Na*m_offs+C3_Na*alfa+O2_Na*theta-C4_Na*(i_on*a^4+gama+m_ons+4*beta+eta);
dO1_Na=IO1_Na*i_off_2+O2_Na*omega+MO1_Na*m_offs+C4_Na*gama-O1_Na*(i_on_2+epsilon+m_ons+delta);
dO2_Na=O1_Na*epsilon+C4_Na*eta-O2_Na*(omega+theta);
dMC0_Na=C0_Na*m_ons+MC1_Na*beta-MC0_Na*(4*alfa+m_offs);
dMC1_Na=C1_Na*m_ons+MC2_Na*2*beta+MC0_Na*4*alfa-MC1_Na*(3*alfa+m_offs+beta);
dMC2_Na=C2_Na*m_ons+MC3_Na*3*beta+MC1_Na*3*alfa-MC2_Na*(2*alfa+m_offs+2*beta);
dMC3_Na=C3_Na*m_ons+MC4_Na*4*beta+MC2_Na*2*alfa-MC3_Na*(alfa+m_offs+3*beta);
dMC4_Na=C4_Na*m_ons+MO1_Na2*delta+MC3_Na*alfa+MO2_Na*theta-MC4_Na*(gama+m_offs+4*beta+eta);
%dMO1_Na=O1_Na*m_ons+MO2_Na*omega+MC4_Na*gama-MO1_Na*(epsilon+m_offs+delta);
dMO1_Na=0;
dMO2_Na=MO1_Na2*epsilon+MC4_Na*eta-MO2_Na*(omega+theta);
dMO1_Na2=O1_Na*m_ons+MO2_Na*omega+MC4_Na*gama-MO1_Na2*(epsilon+m_offs+delta);
%dMO1_Na2=0;
INas=gNas*(O1_Na+O2_Na+MO1_Na2+MO2_Na)*(Vms-ENas);

%T-tubules
ENat=log(Nat/Nast)*R*T/F;
mtinf=1./(1+exp((Vmt+52.2-9)/-7.4));
htinf=1./(1+exp((Vmt+85.6-9)/+5.5));
taumt=(0.001./(101.6*exp(Vmt*0.1135)+0.02268*exp(-0.0717*Vmt))+0.0001)/4.83;
tauht=(0.001./(1.1381e-6*exp(-0.1017*Vmt)+6.537*exp(Vmt*0.08016))+0.0005)/4.83;
dmt=(mtinf-mt)/taumt;
dht=(htinf-ht)/tauht;
%INat=gNat*mt^3*ht*(Vmt-log((Nat+0.12*Kt)/(Nast+0.12*Kst))*R*T/F);

%New description
m_ont=0;
m_offt=0;
a=7.5;
par_H=(-19.8282-50/8.315)*2544.39;
alfat=2.0842e+10*T*exp(par_H/(8.315*T)+50/8.315+0.2864*11.594*Vmt/T);
betat=2.0842e+10*T*exp(-272470/(8.315*T)+691.732/8.315-2.5*11.594*Vmt/T);
gamat=2.8950e+10*T*exp(-196337/(8.315*T)+529.952/8.315+1.5703*11.594*Vmt/T);
deltat=2.8950e+10*T*exp(-133690/(8.315*T)+229.205/8.315-1.558*11.594*Vmt/T);
j_on_2=2.0842e+10*T*exp(-62123/(8.315*T)+28.6847/8.315+0.2888*11.594*Vmt/T);
epsilont=2.8950e+10*T*exp(-85800/(8.315*T)+70.078/8.315);
etat=2.8950e+10*T*exp(-147814/(8.315*T)+338.915/8.315+0.75*11.594*Vmt/T);
par_H=(-26.4132-1.76851/8.315)*2544.39;
thetat=2.0842e+10*T*exp(par_H/(8.315*T)+1.76851/8.315-1.7*11.594*Vmt/T);
omegat=epsilont*thetat*gamat/(etat*deltat);
j_off=0.01*2.8950e+10*T*exp(-287913/(8.3148*T)+786.217/8.315);
j_on=0.05*2.8950e+10*T*exp(-59565/(8.3148*T)+0.00711/8.315);            
deltat_2=2.8950e+10*T*exp(-55701/(8.315*T)-130.639/8.315-3.6498*11.594*Vmt/T);
gamat_2=2.8950e+10*T*exp(116431/(8.315*T)-578.317/8.315+0.7641*11.594*Vmt/T);
j_off_2=deltat_2*j_on_2*gamat*j_off/a^4/(j_on*deltat*a^4*gamat_2);      
dTIC0_Na=TC0_Na*j_on+TIC1_Na*betat/a-TIC0_Na*(4*alfat*a+j_off);
dTIC1_Na=TC1_Na*j_on*a^1+TIC2_Na*2*betat/a+TIC0_Na*4*alfat*a-TIC1_Na*(3*alfat*a+j_off/a+betat/a);
dTIC2_Na=TC2_Na*j_on*a^2+TIC3_Na*3*betat/a+TIC1_Na*3*alfat*a-TIC2_Na*(2*alfat*a+j_off/a^2+2*betat/a);
dTIC3_Na=TC3_Na*j_on*a^3+TIC4_Na*4*betat/a+TIC2_Na*2*alfat*a-TIC3_Na*(alfat*a+j_off/a^3+3*betat/a);
dTIC4_Na=TC4_Na*j_on*a^4+TIO1_Na*deltat_2+TIC3_Na*alfat*a-TIC4_Na*(gamat_2+j_off/a^4+4*betat/a);
dTIO1_Na=TO1_Na*j_on_2+TIC4_Na*gamat_2-TIO1_Na*(deltat_2+j_off_2);
dTC0_Na=TIC0_Na*j_off+TC1_Na*betat+TMC0_Na*m_offt-TC0_Na*(j_on+4*alfat+m_ont);
dTC1_Na=TIC1_Na*j_off/a^1+TC2_Na*2*betat+TMC1_Na*m_offt+TC0_Na*4*alfat-TC1_Na*(j_on*a^1+3*alfat+m_ont+betat);
dTC2_Na=TIC2_Na*j_off/a^2+TC3_Na*3*betat+TMC2_Na*m_offt+TC1_Na*3*alfat-TC2_Na*(j_on*a^2+2*alfat+m_ont+2*betat);
dTC3_Na=TIC3_Na*j_off/a^3+TC4_Na*4*betat+TMC3_Na*m_offt+TC2_Na*2*alfat-TC3_Na*(j_on*a^3+alfat+m_ont+3*betat);
dTC4_Na=TIC4_Na*j_off/a^4+TO1_Na*deltat+TMC4_Na*m_offt+TC3_Na*alfat+TO2_Na*thetat-TC4_Na*(j_on*a^4+gamat+m_ont+4*betat+etat);
dTO1_Na=TIO1_Na*j_off_2+TO2_Na*omegat+TMO1_Na*m_offt+TC4_Na*gamat-TO1_Na*(j_on_2+epsilont+m_ont+deltat);
dTO2_Na=TO1_Na*epsilont+TC4_Na*etat-TO2_Na*(omegat+thetat);
dTMC0_Na=TC0_Na*m_ont+TMC1_Na*betat-TMC0_Na*(4*alfat+m_offt);
dTMC1_Na=TC1_Na*m_ont+TMC2_Na*2*betat+TMC0_Na*4*alfat-TMC1_Na*(3*alfat+m_offt+betat);
dTMC2_Na=TC2_Na*m_ont+TMC3_Na*3*betat+TMC1_Na*3*alfat-TMC2_Na*(2*alfat+m_offt+2*betat);
dTMC3_Na=TC3_Na*m_ont+TMC4_Na*4*betat+TMC2_Na*2*alfat-TMC3_Na*(alfat+m_offt+3*betat);
dTMC4_Na=TC4_Na*m_ont+TMO1_Na*deltat+TMC3_Na*alfat+TMO2_Na*thetat-TMC4_Na*(gamat+m_offt+4*betat+etat);
dTMO1_Na=TO1_Na*m_ont+TMO2_Na*omegat+TMC4_Na*gamat-TMO1_Na*(epsilont+m_offt+deltat);
dTMO2_Na=TMO1_Na*epsilont+TMC4_Na*etat-TMO2_Na*(omegat+thetat);
INat=gNat*(TO1_Na+TO2_Na+TMO1_Na+TMO2_Na)*(Vmt-ENat);


%*****Persistent sodium current [uA]*****
%Surface
INapss=gNapss/(1+exp(-54-Vms)/8)*(Vms-log((Nae+0.12*Ke)/(Nass+0.12*Kss))*R*T/F);
%T-tubules
INapst=gNapst/(1+exp(-54-Vmt)/8)*(Vmt-log((Nat+0.12*Kt_1)/(Nast+0.12*Kst))*R*T/F);


%*****Currents through L-type calcium channels [uA]*****
%Calcium L-type current
%Surface
alfas=1997*exp(0.012*(Vms-35));
betas=88.2*exp(-0.065*(Vms-22));
gamas=55.4*Cads; 
omega=10;
a=2;
b=2;
f=300;
g=4000;
f2=5;
g2=7000;
alfa2s=alfas*a;
beta2s=betas/b;
yinfs=0.82/(1+exp((Vms+28.5)/7.8))+0.1;
tauys=0.001/((0.00512*exp(-Vms/39.8))+0.00653/(0.5+exp(-Vms/7.1)));
dCst=betas*C1+omega*Ccast-(4*alfas+gamas)*Cst;
dC1=4*alfas*Cst+2*betas*C2+omega/b*Cca1-(betas+3*alfas+gamas*a)*C1;
dC2=3*alfas*C1+3*betas*C3+omega/b^2*Cca2-(2*betas+2*alfas+gamas*a^2)*C2;
dC3=2*alfas*C2+4*betas*C4+omega/b^3*Cca3-(3*betas+alfas+gamas*a^3)*C3;
dC4=alfas*C3+g*Co+omega/b^4*Cca4-(4*betas+f+gamas*a^4)*C4;
dCo=f*C4-g*Co;
dCcast=beta2s*Cca1+gamas*Cst-(4*alfa2s+omega)*Ccast;
dCca1=4*alfa2s*Ccast+2*beta2s*Cca2+gamas*a*C1-(beta2s+3*alfa2s+omega/b)*Cca1;
dCca2=3*alfa2s*Cca1+3*beta2s*Cca3+gamas*a^2*C2-(2*beta2s+2*alfa2s+omega/b^2)*Cca2;
dCca3=2*alfa2s*Cca2+4*beta2s*Cca4+gamas*a^3*C3-(3*beta2s+alfa2s+omega/b^3)*Cca3;
dCca4=alfa2s*Cca3+g2*Ccao+gamas*a^4*C4-(4*beta2s+f2+omega/b^4)*Cca4;
dCcao=f2*Cca4-g2*Ccao;
dys=(yinfs-ys)/tauys;
ICas=PCas*4*(Co+Ccao)*ys*(Vms*F^2/(R*T))*(0.001*exp(2*Vms*F/(R*T))-0.341*Cae)/(exp(2*Vms*F/(R*T))-1);

%T-tubules
ddt=0;
dft=0;
alfat=1997*exp(0.012*(Vmt-35));
betat=88.2*exp(-0.065*(Vmt-22));
alfa2t=alfat*a;
beta2t=betat/b;
gamat=55.4*Cadt;
yinft=0.82/(1+exp((Vmt+28.5)/7.8))+0.1;
tauyt=0.001/((0.00512*exp(-Vmt/39.8))+0.00653/(0.5+exp(-Vmt/7.1)));
dTCst=betat*TC1+omega*TCcast-(4*alfat+gamat)*TCst;
dTC1=4*alfat*TCst+2*betat*TC2+omega/b*TCca1-(betat+3*alfat+gamat*a)*TC1;
dTC2=3*alfat*TC1+3*betat*TC3+omega/b^2*TCca2-(2*betat+2*alfat+gamat*a^2)*TC2;
dTC3=2*alfat*TC2+4*betat*TC4+omega/b^3*TCca3-(3*betat+alfat+gamat*a^3)*TC3;
dTC4=alfat*TC3+g*TCo+omega/b^4*TCca4-(4*betat+f+gamat*a^4)*TC4;
dTCo=f*TC4-g*TCo;
dTCcast=beta2t*TCca1+gamat*TCst-(4*alfa2t+omega)*TCcast;
dTCca1=4*alfa2t*TCcast+2*beta2t*TCca2+gamat*a*TC1-(beta2t+3*alfa2t+omega/b)*TCca1;
dTCca2=3*alfa2t*TCca1+3*beta2t*TCca3+gamat*a^2*TC2-(2*beta2t+2*alfa2t+omega/b^2)*TCca2;
dTCca3=2*alfa2t*TCca2+4*beta2t*TCca4+gamat*a^3*TC3-(3*beta2t+alfa2t+omega/b^3)*TCca3;
dTCca4=alfa2t*TCca3+g2*TCcao+gamat*a^4*TC4-(4*beta2t+f2+omega/b^4)*TCca4;
dTCcao=f2*TCca4-g2*TCcao;
dyt=(yinft-yt)/tauyt;
ICat=PCat*4*(TCo+TCcao)*yt*(Vmt*F^2/(R*T))*(0.001*exp(2*Vmt*F/(R*T))-0.341*Cat_1)/(exp(2*Vmt*F/(R*T))-1);

%Potassium L-type current
%Surface
IKls=PKls/(1-(ICas+ICat)/(0.265*(Sms+Smt)))*(Co+Ccao)*ys*Vms*F^2/(R*T)*(Kss*exp(Vms*F/(R*T))-Ke)/(exp(Vms*F/(R*T))-1);
%T-tubules
IKlt=PKlt/(1-(ICas+ICat)/(0.265*(Sms+Smt)))*(TCo+TCcao)*yt*Vmt*F^2/(R*T)*(Kst*exp(Vmt*F/(R*T))-Kt_1)/(exp(Vmt*F/(R*T))-1);

%Sodium L-type current
%Surface
INals=0;
%T-tubules
INalt=0;


%*****Fast component of delayed rectifier potassium current [uA]*****
%Surface
EKrs=log(Ke/Kss)*R*T/F;
xrs_inf=1/(1+exp(-(Vms+26)/7));
tauxrs=0.001*450/(1+exp(-(Vms+45)/10))*6/(1+exp((Vms+30)/11.5));
dxrs=(xrs_inf-xrs)/tauxrs;
xris_inf=1/(1+exp((Vms+88)/24));
tauxris=0.001*3/(1+exp(-(Vms+60)/20))*1.12/(1+exp((Vms-60)/20));
dxris=(xris_inf-xris)/tauxris;
IKrs=qKrs*sqrt(Ke/5.4)*xrs*xris*(Vms-EKrs);
%T-tubules
EKrt=log(Kt_1/Kst)*R*T/F;
xrt_inf=1/(1+exp(-(Vmt+26)/7));
tauxrt=0.001*450/(1+exp(-(Vmt+45)/10))*6/(1+exp((Vmt+30)/11.5));
dxrt=(xrt_inf-xrt)/tauxrt;
xrit_inf=1/(1+exp((Vmt+88)/24));
tauxrit=0.001*3/(1+exp(-(Vmt+60)/20))*1.12/(1+exp((Vmt-60)/20));
dxrit=(xrit_inf-xrit)/tauxrit;
IKrt=qKrt*sqrt(Kt_1/5.4)*xrt*xrit*(Vmt-EKrt);


%*****Slow component of delayed rectifier potassium current [uA]*****
%Surface
EKss=log((Ke+0.03*Nae)/(Kss+0.03*Nass))*R*T/F;
xsinfs=1/(1+exp(-(Vms+28.529)/20.949))^4; 
tauxss=0.105+40./(1+exp(-(Vms+10)/0.2)).^0.0133./(1+exp((Vms+90)/129)).^2.6;
dxss=(xsinfs-xss)/tauxss;
IKss=qKss*xss*(Vms-EKss);
%T-tubules
EKst=log((Kt_1+0.03*Nat)/(Kst+0.03*Nast))*R*T/F;
xsinft=1/(1+exp(-(Vmt+28.529)/20.949))^4; 
tauxst=0.105+40./(1+exp(-(Vmt+10)/0.2)).^0.0133./(1+exp((Vmt+90)/129)).^2.6;
dxst=(xsinft-xst)/tauxst;
IKst=qKst*xst*(Vmt-EKst);


%*****Inwardly rectifying potassium current [uA]*****
%Surface
EK1s=EKrs;
MgBuf=0.0356;
SPM=1.4613e-3; 
fac=1.0648; 
phi=0.8838; 
KiMgs=2.8*exp(-(Vms-fac*EK1s)/180);
KbMgs=0.45*exp(-(Vms-fac*EK1s)/20);
Kd1SPMs=0.0007*exp(-(Vms-fac*EK1s+8*MgBuf)/4.8);
Kd2SPMs=0.04*exp(-(Vms-fac*EK1s)/9.1);
temps=1+MgBuf/KbMgs;
rec1s=temps^2/(SPM/Kd1SPMs+MgBuf/KiMgs+temps^3);
rec2s=1/(1+SPM/Kd2SPMs);
xK1infs=phi*rec1s+(1-phi)*rec2s;
IK1s=gK1s*(T/35-7.857)*sqrt(Ke/5.4)*xK1infs*(Vms-EK1s);
%T-tubules
EK1t=EKrt;
KiMgt=2.8*exp(-(Vmt-fac*EK1t)/180);
KbMgt=0.45*exp(-(Vmt-fac*EK1t)/20);
Kd1SPMt=0.0007*exp(-(Vmt-fac*EK1t+8*MgBuf)/4.8);
Kd2SPMt=0.04*exp(-(Vmt-fac*EK1t)/9.1);
tempt=1+MgBuf/KbMgt;
rec1t=tempt^2/(SPM/Kd1SPMt+MgBuf/KiMgt+tempt^3);
rec2t=1/(1+SPM/Kd2SPMt);
xK1inft=phi*rec1t+(1-phi)*rec2t;
IK1t=gK1t*(T/35-7.857)*sqrt(Kt_1/5.4)*xK1inft*(Vmt-EK1t);


%*****Plateau potassium current [uA]*****
%Surface
EKps=EKrs;
kps=1/(1+exp((20-Vms)/5));
IKps=gKps*kps*(Vms-EKps);
%T-tubules
EKpt=EKrt;
kpt=1/(1+exp((20-Vmt)/5));
IKpt=gKpt*kpt*(Vmt-EKpt);


%*****Time-dependent transient outward potassium current [uA]*****
%Surface
EKtos=EKrs;
minfs=1/(1+exp(-(Vms-20)/6));
taums=0.0095*exp((-(Vms+40)^2)/1800)+0.0008;
hinfs=1/(1+exp((Vms+20)/5));
tauhs=0.085*exp((-(Vms+45)^2)/320)+0.005/(1+exp((Vms-63)/5))+0.003;
ams=minfs/taums;
bms=1/taums-ams;
ahs=hinfs/tauhs;
bhs=1/tauhs-ahs;
r1s=1-r2s-r3s-r4s;
dr2s=r1s*ams+r3s*ahs-r2s*(bms+bhs);
dr3s=r4s*ams+r2s*bhs-r3s*(bms+ahs);
dr4s=r3s*bms+r1s*bhs-r4s*(ams+ahs);
IKtos=gKtos*r2s*(Vms-EKtos);
%T-tubules
EKtot=EKrt;
r2tinf=1/(1+exp(-(Vmt-20)/6));
taur2t=0.0095*exp((-(Vmt+40)^2)/1800)+0.0008;
r3tinf=1/(1+exp((Vmt+20)/5));
taur3t=0.085*exp((-(Vmt+45)^2)/320)+0.005/(1+exp((Vmt-63)/5))+0.003;
dr2t=(r2tinf-r2t)/taur2t;
dr3t=(r3tinf-r3t)/taur3t;
dr4t=0;
IKtot=gKtot*r2t*r3t*(Vmt-EKtot);


%*****Na-activated potassium current [uA]*****
%Surface
EKsNas=EKrs;
IKsNas=gKsNas*(0.8-(0.65./(1+exp((Vms+125)/15)))).*0.85./(1+(66./Nass)^2.8)*(Vms-EKsNas);
%T-tubules
EKsNat=EKrt;
IKsNat=gKsNat*(0.8-(0.65./(1+exp((Vmt+125)/15)))).*0.85./(1+(66./Nast)^2.8)*(Vmt-EKsNat);


%*****Nonspecific Ca-activated sodium current [uA]*****
%Surface
InsNas=PnsNas*Vms*F^2/(R*T)*(0.75*Nass*exp(Vms*F/(R*T))-0.75*Nae)/(exp(Vms*F/(R*T))-1)/(1+(0.0025/Cass)^3);
%T-tubules
InsNat=PnsNat*Vmt*F^2/(R*T)*(0.75*Nast*exp(Vmt*F/(R*T))-0.75*Nat)/(exp(Vmt*F/(R*T))-1)/(1+(0.0025/Cast)^3);


%*****Nonspecific Ca-activated potassium current [uA]*****
%Surface
InsKs=PnsKs*Vms*F^2/(R*T)*(0.75*Kss*exp(Vms*F/(R*T))-0.75*Ke)/(exp(Vms*F/(R*T))-1)/(1+(0.0025/Cass)^3);
%T-tubules
InsKt=PnsKt*Vmt*F^2/(R*T)*(0.75*Kst*exp(Vmt*F/(R*T))-0.75*Kt_1)/(exp(Vmt*F/(R*T))-1)/(1+(0.0025/Cast)^3);


%*****Background sodium current [uA]***** 
%Surface
INabs=gNabs*(Vms-ENas);
%T-tubules
INabt=gNabt*(Vmt-ENat);


%*****Background calcium current [uA]*****
%Surface
ECas=log(Cae/Cass)*R*T/(2*F);
ICabs=gCabs*(Vms-ECas);
%T-tubules
ECat=log(Cat_1/Cast)*R*T/(2*F);
ICabt=gCabt*(Vmt-ECat);


%*****Na/Ca-exchange current [uA]*****
%Surface
INaCas=INaCamaxs*exp(-0.85*Vms*F/(R*T))*(exp(Vms*F/(R*T))*Nass^3*Cae-Nae^3*Cass)/(1+0.0001*exp(-0.85*Vms*F/(R*T))*(exp(Vms*F/(R*T))*Nass^3*Cae+Nae^3*Cass));
%T-tubules
INaCat=INaCamaxt*exp(-0.85*Vmt*F/(R*T))*(exp(Vmt*F/(R*T))*Nast^3*Cat_1-Nat^3*Cast)/(1+0.0001*exp(-0.85*Vmt*F/(R*T))*(exp(Vmt*F/(R*T))*Nast^3*Cat_1+Nat^3*Cast));


%*****Na/K-exchange current [uA]*****
%Surface
INaKs=INaKmaxs/(1+0.1245*exp(-0.1*Vms*F/(R*T))+0.0365*1/7*(exp(Nae/67.3)-1)*exp(-Vms*F/(R*T)))*1/(1+(10/Nass)^2.5)*Ke/(Ke+1.5);
%T-tubules
INaKt=INaKmaxt/(1+0.1245*exp(-0.1*Vmt*F/(R*T))+0.0365*1/7*(exp(Nat/67.3)-1)*exp(-Vmt*F/(R*T)))*1/(1+(10/Nast)^2.5)*Kt_1/(Kt_1+1.5);


%*****Sarcolemmal calcium pump current [uA]***** 
%Surface
IpCas=IpCamaxs*Cass/(0.0005+Cass);
%T-tubules
IpCat=IpCamaxt*Cast/(0.0005+Cast);


%*****ATP-dependent potassium current [uA]***** 
%Surface
EKatps=EKrs;
IKatps=gKatps*1/(1+(ATPi/0.114)^2)*(Ke/4)^0.24*(Vms-EKatps);
%T-tubules
EKatpt=EKrt;
IKatpt=gKatpt*1/(1+(ATPi/0.114)^2)*(Kt_1/4)^0.24*(Vmt-EKatpt);


%*****Circulation current [uA]*****
Icirc=1000*(Vmt/Rst-Vms/Rst);



%*****IONIC FLUXES***************************************************************
%*****Ionic fluxes between T-tubular and extracellular cleft spaces [umol/s]*****
TauNa_te=0.2;
Tau_Ca_te=0.24;
Tau_K_te=0.2;

if ICCT==0
    TauNa_te=0.000001;
    Tau_Ca_te=0.000001;
    Tau_K_te=0.000001;
end;

JteCa_1=Vt_1/Tau_Ca_te*(Cat_1-Cae);
JteCa_2=Vt_2/Tau_Ca_te*(Cat_2-Cae);
JteCa_3=Vt_3/Tau_Ca_te*(Cat_3-Cae);
JteCa_4=Vt_4/Tau_Ca_te*(Cat_4-Cae);
JteCa_5=Vt_5/Tau_Ca_te*(Cat_5-Cae);
JteCa_6=Vt_6/Tau_Ca_te*(Cat_6-Cae);
JteCa_7=Vt_7/Tau_Ca_te*(Cat_7-Cae);
JteCa_8=Vt_8/Tau_Ca_te*(Cat_8-Cae);
JteCa_9=Vt_9/Tau_Ca_te*(Cat_9-Cae);

JteK_1=Vt_1/Tau_K_te*(Kt_1-Ke);
JteK_2=Vt_2/Tau_K_te*(Kt_2-Ke);
JteK_3=Vt_3/Tau_K_te*(Kt_3-Ke);
JteK_4=Vt_4/Tau_K_te*(Kt_4-Ke);
JteK_5=Vt_5/Tau_K_te*(Kt_5-Ke);
JteK_6=Vt_6/Tau_K_te*(Kt_6-Ke);
JteK_7=Vt_7/Tau_K_te*(Kt_7-Ke);
JteK_8=Vt_8/Tau_K_te*(Kt_8-Ke);
JteK_9=Vt_9/Tau_K_te*(Kt_9-Ke);

JteNa=Vt/TauNa_te*(Nat-Nae);


%*****Ca uptake into NSR [umol/s]*****
JCaSRup=Vmyo*(0.3*(Cai/0.000168)^1.2-0.9*(CaSRup/3.29))/(1+(Cai/0.000168)^1.2+(CaSRup/3.29));
JCaSRleak=0;


%*****Ca translocation from NSR to JSR [umol/s]*****
Tau_SRCa_tr=0.02;
JCaSRtr_t=VSRrel_t/Tau_SRCa_tr*(CaSRup-CaSRrel_t);
JCaSRtr_s=VSRrel_s/Tau_SRCa_tr*(CaSRup-CaSRrel_s);


%*****Ca-induced Ca release from JSR [umol/s]*****
kap=12.15E+12;
kam=576*1.0265;
kbp=4.05E+9;
kbm=1930;
kcp=100;
kcm=0.8;
%Surface
dF1s=F2s*kam-F1s*kap*Cads^4;
dF2s=F1s*kap*Cads^4+F3s*kbm+F4s*kcm-F2s*(kam+kbp*Cads^3+kcp);
dF3s=F2s*kbp*Cads^3-F3s*kbm;
dF4s=F2s*kcp-F4s*kcm;
JCaSRrel_s=1*1800*VSRrel_s*(F2s+F3s)*(CaSRrel_s-Cads);
%T-tubules
dF1t=F2t*kam-F1t*kap*Cadt^4;
dF2t=F1t*kap*Cadt^4+F3t*kbm+F4t*kcm-F2t*(kam+kbp*Cadt^3+kcp);
dF3t=F2t*kbp*Cadt^3-F3t*kbm;
dF4t=F2t*kcp-F4t*kcm;
JCaSRrel_t=1*1800*VSRrel_t*(F2t+F3t)*(CaSRrel_t-Cadt);



%*****Ca BINDING TO TROPONIN*****************************
%*****Ca binding to troponin high affinity sites [-]*****
dBTRH=20000*Cai*(1-BTRH)-0.07*BTRH;

%*****Ca binding to troponin low affinity sites [-]*****
dBTRL=40000*Cai*(1-BTRL)-BTRL*40;



%*****IONIC CONCENTRATIONS*************
%*****Ca concentration in NSR [mM]*****
dCaSRup=(JCaSRup-JCaSRleak-JCaSRtr_t-JCaSRtr_s)/VSRup;

%*****Ca concentrations in JSR [mM]*****
dCaSRrel_t=1/(1+15*0.8/(0.8+CaSRrel_t)^2)*(JCaSRtr_t-JCaSRrel_t)/VSRrel_t;
dCaSRrel_s=1/(1+15*0.8/(0.8+CaSRrel_s)^2)*(JCaSRtr_s-JCaSRrel_s)/VSRrel_s;


%*****Ca concentration in dyadic spaces [mM]*****
%Surface
Tau_ssds=5.3453e-007;
JCassds=(Cass-Cads)*Vd_s/Tau_ssds;
dCads=1/(1+0.05*0.00238/(0.00238+Cads)^2)*(-(ICas)/(2*F*Vd_s)+JCaSRrel_s/Vd_s+JCassds/Vd_s);
%T-tubules
Tau_stdt=5.3453e-007;
JCastdt=(Cast-Cadt)*Vd_t/Tau_stdt;
dCadt=1/(1+0.05*0.00238/(0.00238+Cadt)^2)*(-(ICat)/(2*F*Vd_t)+JCaSRrel_t/Vd_t+JCastdt/Vd_t);


%*****Ca concentration in submembrane spaces [mM]*****
%Surface
Tau_Ca_pss=4.42; 
Tau_Ca_css=4.00362319E-5; %Tau_Ca_ssc=2.8e-3 s
JCapss=(Cap-Cass)*Vs_s/Tau_Ca_pss*DIALYSIS;
JCacss=(Cai-Cass)*Vs_s/Tau_Ca_css;
JCastss=(Cast-Cass)*Pstss; %Tau_Ca_stss=4.8e-3 s
dCass=1/(1+0.05*0.00238/(0.00238+Cass)^2)*((-2*INaCas+ICabs+IpCas)/(-2*F*Vs_s)+(JCapss-JCassds+JCacss+JCastss)/Vs_s);
%T-tubules
Tau_Ca_cst=4.00362319E-5; %Tau_Ca_stc=2.7e-3 s
JCacst=(Cai-Cast)*Vs_t/Tau_Ca_cst;
dCast=1/(1+0.05*0.00238/(0.00238+Cast)^2)*((-2*INaCat+ICabt+IpCat)/(-2*F*Vs_t)+(-JCastdt+JCacst-JCastss)/Vs_t);

%*****Na concentration in submembrane spaces [mM]*****
%Surface
Tau_Na_css=4.00362319E-5; 
JNacss=(Nai-Nass)*Vs_s/Tau_Na_css;
JNastss=(Nast-Nass)*Pstss;
dNass=-(INas+INapss+INals+InsNas+INabs+3*INaCas+3*INaKs)/(F*Vs_s)+(JNacss+JNastss)/Vs_s;
%T-tubules
Tau_Na_cst=4.00362319E-5;
JNacst=(Nai-Nast)*Vs_t/Tau_Na_cst;
dNast=-(INat+INapst+INalt+InsNat+INabt+3*INaCat+3*INaKt)/(F*Vs_t)+(JNacst-JNastss)/Vs_t;

%*****K concentration in submembrane spaces [mM]*****
%Surface
Tau_K_css=4.00362319E-5; 
JKcss=(Ki-Kss)*Vs_s/Tau_K_css;
JKstss=(Kst-Kss)*Pstss;
dKss=-(-IKext+IKss+IKrs+IK1s+IKps+IKls+IKsNas+InsKs-2*INaKs+IKatps+IKtos)/(F*Vs_s)+(JKcss+JKstss)/Vs_s;
%T-tubules
Tau_K_cst=4.00362319E-5;  
JKcst=(Ki-Kst)*Vs_t/Tau_K_cst;
dKst=-(IKst+IKrt+IK1t+IKpt+IKlt+IKsNat+InsKt-2*INaKt+IKatpt+IKtot)/(F*Vs_t)+(JKcst-JKstss)/Vs_t;


%*****Ca concentration in cytosol [mM]*****
dCai=1/(1+0.05*0.00238/(0.00238+Cai)^2)*((-JCacst-JCacss+JCaSRleak-JCaSRup)/Vmyo-dBTRH*0.14-dBTRL*0.07);

%*****Na concentration in cytosol [mM]*****
dNai=-(JNacst+JNacss)/Vmyo;

%*****K concentration in cytosol [mM]*****
dKi=-(JKcst+JKcss)/Vmyo;


%*****Na concentration in T-tubules [mM]*****
dNat=((INat+INapst+INalt+InsNat+INabt+3*INaCat+3*INaKt)/F-JteNa)/Vt;

%*****Ca concentrations in T-tubules [mM]*****
Tau_tCa_12=Tau_Ca_te*3.14159*(rt_1^2-rt_2^2)/(2*3.14159*rt_2*Lt)*Vt_2/Vt_1;
Tau_tCa_23=Tau_Ca_te*3.14159*(rt_2^2-rt_3^2)/(2*3.14159*rt_3*Lt)*Vt_3/Vt_2;
Tau_tCa_34=Tau_Ca_te*3.14159*(rt_3^2-rt_4^2)/(2*3.14159*rt_4*Lt)*Vt_4/Vt_3;
Tau_tCa_45=Tau_Ca_te*3.14159*(rt_4^2-rt_5^2)/(2*3.14159*rt_5*Lt)*Vt_5/Vt_4;
Tau_tCa_56=Tau_Ca_te*3.14159*(rt_5^2-rt_6^2)/(2*3.14159*rt_6*Lt)*Vt_6/Vt_5;
Tau_tCa_67=Tau_Ca_te*3.14159*(rt_6^2-rt_7^2)/(2*3.14159*rt_7*Lt)*Vt_7/Vt_6;
Tau_tCa_78=Tau_Ca_te*3.14159*(rt_7^2-rt_8^2)/(2*3.14159*rt_8*Lt)*Vt_8/Vt_7;
Tau_tCa_89=Tau_Ca_te*3.14159*(rt_8^2-rt_9^2)/(2*3.14159*rt_9*Lt)*Vt_9/Vt_8;
JtCa_12=Vt_2/Tau_tCa_12*(Cat_1-Cat_2);
JtCa_23=Vt_3/Tau_tCa_23*(Cat_2-Cat_3);
JtCa_34=Vt_4/Tau_tCa_34*(Cat_3-Cat_4);
JtCa_45=Vt_5/Tau_tCa_45*(Cat_4-Cat_5);
JtCa_56=Vt_6/Tau_tCa_56*(Cat_5-Cat_6);
JtCa_67=Vt_7/Tau_tCa_67*(Cat_6-Cat_7);
JtCa_78=Vt_8/Tau_tCa_78*(Cat_7-Cat_8);
JtCa_89=Vt_9/Tau_tCa_89*(Cat_8-Cat_9);
dCat_1=((-2*INaCat+ICat+ICabt+IpCat)/(2*F)-JteCa_1-JtCa_12)/Vt_1;
dCat_2=(-JteCa_2+JtCa_12-JtCa_23)/Vt_2;
dCat_3=(-JteCa_3+JtCa_23-JtCa_34)/Vt_3;
dCat_4=(-JteCa_4+JtCa_34-JtCa_45)/Vt_4;
dCat_5=(-JteCa_5+JtCa_45-JtCa_56)/Vt_5;
dCat_6=(-JteCa_6+JtCa_56-JtCa_67)/Vt_6;
dCat_7=(-JteCa_7+JtCa_67-JtCa_78)/Vt_7;
dCat_8=(-JteCa_8+JtCa_78-JtCa_89)/Vt_8;
dCat_9=(-JteCa_9+JtCa_89)/Vt_9;

%*****K concentrations in T-tubules [mM]*****
Tau_tK_12=Tau_K_te*3.14159*(rt_1^2-rt_2^2)/(2*3.14159*rt_2*Lt)*Vt_2/Vt_1;
Tau_tK_23=Tau_K_te*3.14159*(rt_2^2-rt_3^2)/(2*3.14159*rt_3*Lt)*Vt_3/Vt_2;
Tau_tK_34=Tau_K_te*3.14159*(rt_3^2-rt_4^2)/(2*3.14159*rt_4*Lt)*Vt_4/Vt_3;
Tau_tK_45=Tau_K_te*3.14159*(rt_4^2-rt_5^2)/(2*3.14159*rt_5*Lt)*Vt_5/Vt_4;
Tau_tK_56=Tau_K_te*3.14159*(rt_5^2-rt_6^2)/(2*3.14159*rt_6*Lt)*Vt_6/Vt_5;
Tau_tK_67=Tau_K_te*3.14159*(rt_6^2-rt_7^2)/(2*3.14159*rt_7*Lt)*Vt_7/Vt_6;
Tau_tK_78=Tau_K_te*3.14159*(rt_7^2-rt_8^2)/(2*3.14159*rt_8*Lt)*Vt_8/Vt_7;
Tau_tK_89=Tau_K_te*3.14159*(rt_8^2-rt_9^2)/(2*3.14159*rt_9*Lt)*Vt_9/Vt_8;
JtK_12=Vt_2/Tau_tK_12*(Kt_1-Kt_2);
JtK_23=Vt_3/Tau_tK_23*(Kt_2-Kt_3);
JtK_34=Vt_4/Tau_tK_34*(Kt_3-Kt_4);
JtK_45=Vt_5/Tau_tK_45*(Kt_4-Kt_5);
JtK_56=Vt_6/Tau_tK_56*(Kt_5-Kt_6);
JtK_67=Vt_7/Tau_tK_67*(Kt_6-Kt_7);
JtK_78=Vt_8/Tau_tK_78*(Kt_7-Kt_8);
JtK_89=Vt_9/Tau_tK_89*(Kt_8-Kt_9);
dKt_1=((IKst+IKrt+IK1t+IKpt+IKsNat+IKlt+InsKt-2*INaKt+IKatpt+IKtot)/F-JteK_1-JtK_12)/Vt_1;
dKt_2=(-JteK_2+JtK_12-JtK_23)/Vt_2;
dKt_3=(-JteK_3+JtK_23-JtK_34)/Vt_3;
dKt_4=(-JteK_4+JtK_34-JtK_45)/Vt_4;
dKt_5=(-JteK_5+JtK_45-JtK_56)/Vt_5;
dKt_6=(-JteK_6+JtK_56-JtK_67)/Vt_6;
dKt_7=(-JteK_7+JtK_67-JtK_78)/Vt_7;
dKt_8=(-JteK_8+JtK_78-JtK_89)/Vt_8;
dKt_9=(-JteK_9+JtK_89)/Vt_9;


%*****Ion concentrations in extracellular cleft space [mM]*****
Tau_Na_eb=14.3; 
Tau_K_eb=10;    
Tau_Ca_eb=24.7; 

if ICCC==0
Tau_Na_eb=0.00001;
Tau_K_eb=0.00001;
Tau_Ca_eb=0.00001;
end;

dNae=(Nab-Nae)/Tau_Na_eb+(INas+INapss+INals+InsNas+INabs+3*INaCas+3*INaKs)/(F*Ve)+JteNa/Ve;
dKe=(Kb-Ke)/Tau_K_eb+(-IKequ+IKss+IKrs+IK1s+IKps+IKls+IKsNas+InsKs-2*INaKs+IKatps+IKtos)/(F*Ve)+(JteK_1+JteK_2+JteK_3+JteK_4+JteK_5+JteK_6+JteK_7+JteK_8+JteK_9)/Ve;
dCae=(Cab-Cae)/Tau_Ca_eb+(ICas-2*INaCas+ICabs+IpCas)/(2*F*Ve)+(JteCa_1+JteCa_2+JteCa_3+JteCa_4+JteCa_5+JteCa_6+JteCa_7+JteCa_8+JteCa_9)/Ve;



%*****MEMBRANE VOLTAGE*********************************
%*****Membrane voltage in current clamp conditions*****
if VCLAMP==0
dVms=1000*(IKext+Icirc-INas-INapss-ICas-INals-IKls-IKss-IKrs-IK1s-IKps-IKsNas-IKatps-InsNas-InsKs-INabs-ICabs-INaCas-INaKs-IpCas-IKtos)/Cms;
dVmt=1000*(-Icirc-INat-INapst-ICat-INalt-IKlt-IKst-IKrt-IK1t-IKpt-IKsNat-IKatpt-InsNat-InsKt-INabt-ICabt-INaCat-INaKt-IpCat-IKtot)/Cmt;
end;


%*****Membrane voltage in voltage clamp conditions*****
if VCLAMP==1
dVms=1000*(IKext+Icirc-INas-INapss-ICas-INals-IKls-IKrs-IKss-IK1s-IKps-IKsNas-IKatps-InsNas-InsKs-INabs-ICabs-INaCas-INaKs-IpCas-IKtos)/Cms;
dVmt=1000*(-Icirc-INat-INapst-ICat-INalt-IKlt-IKst-IKrt-IK1t-IKpt-IKsNat-IKatpt-InsNat-InsKt-INabt-ICabt-INaCat-INaKt-IpCat-IKtot)/Cmt;
end;



dr=[dVms; dms; dhs; dxss; dr2s; dr3s; dCai; dVmt; dmt; dht; dxst; ddt; dft; dKt_1; dNat; dCat_1; dNai; dKi; dBTRH; dBTRL; dCaSRup; dCaSRrel_t; dCadt; dF1t; dF2t; dF3t; dF4t; dr4s; dCst; dC1; dC2; dC3; dC4; dCo; dCcast; dCca1; dCca2; dCca3; dCca4; dCcao; dys; dTCst; dTC1; dTC2; dTC3; dTC4; dTCo; dTCcast; dTCca1; dTCca2; dTCca3; dTCca4; dTCcao; dyt; dr2t; dr3t; dr4t; dxrs; dxrt; dxris; dxrit; dC0_Na; dC1_Na; dC2_Na; dC3_Na; dC4_Na; dO1_Na; dO2_Na; dIC0_Na; dIC1_Na; dIC2_Na; dIC3_Na; dIC4_Na; dIO1_Na; dMC0_Na; dMC1_Na; dMC2_Na; dMC3_Na; dMC4_Na; dMO1_Na; dMO2_Na; dTC0_Na; dTC1_Na; dTC2_Na; dTC3_Na; dTC4_Na; dTO1_Na; dTO2_Na; dTIC0_Na; dTIC1_Na; dTIC2_Na; dTIC3_Na; dTIC4_Na; dTIO1_Na; dTMC0_Na; dTMC1_Na; dTMC2_Na; dTMC3_Na; dTMC4_Na; dTMO1_Na; dTMO2_Na; dMO1_Na2;dCat_2; dCat_3; dCat_4; dCat_5; dCat_6; dCat_7; dCat_8; dCat_9; dKt_2; dKt_3; dKt_4; dKt_5; dKt_6; dKt_7; dKt_8; dKt_9; dKe; dNae; dCae; dCads; dCaSRrel_s; dF1s; dF2s; dF3s; dF4s; dKss; dNass; dCass; dKst; dNast; dCast];